<script lang="ts" setup>
import { type Product } from '@/types/Product'
import ProductList from '@/components/ProductList.vue'
import { ref, nextTick, onMounted } from 'vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue'
import ReceiptCard from './ReceiptCard.vue'
import MemberCard from './MemberCard.vue'
import { useReceiptStore } from '@/stores/receipt'
import ReceiptDialog from './ReceiptDialog.vue'
import { provide } from 'vue'
import { useProductStore } from '@/stores/product'
import ReceiptPayment from './ReceiptPayment.vue'
import ReceiptPromotion from './ReceiptPromotion.vue'
import { useMemberStore } from '@/stores/member'
import { usePosStore } from '@/stores/pos'
import type { ReceiptItem } from '@/types/ReceiptItem'
import { useMessageStore } from '@/stores/message'
const memberStore = useMemberStore()
const receiptStore = useReceiptStore()
const messagesStore = useMessageStore()
const dialog = ref(false)
const posStore = usePosStore()
const product = ref<Product>()
provide('receiptDialog', dialog)

const tab = ref(1)
function selected(p: Product) {
  if (!p.id) return
  product.value = p
  const newReceiptItem: ReceiptItem = {
    id: 1,
    name: p.name,
    price: p.price,
    qty: 1,
    productId: p.id
  }
  receiptStore.addReceiptItem(newReceiptItem)
  nextTick(() => {
    if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
  })
  // if (divReceiptItems.value) divReceiptItems.value.scrollTop = divReceiptItems.value.scrollHeight
}

const showReceipt = async function () {
  console.log(receiptStore.receipt)

  if (receiptStore.receiptItems.length > 0) {
    receiptStore.checkPayment()
    console.log(receiptStore.payment)
    console.log(receiptStore.receipt)
    console.log(receiptStore.receiptItems)
    // receiptStore.addreceipts()
    // receiptStore.currentStep = 1
  } else {
    messagesStore.showMessage('Please select the product before paying.')
  }
}

const clear = function () {
  receiptStore.clear()
}
onMounted(async () => {
  await posStore.getProducts()
})
const divReceiptItems = ref<HTMLElement | null>(null)
</script>

<template>
  <div fluid class="ma-0 bg-grey-darken-4">
    <v-container fluid class="ma-0 bg-grey-darken-4">
      <v-stepper v-if="receiptStore.currentStep === 1" model-value="1">
        <!-- Step 1 content -->
        <v-stepper-header class="bg-teal-darken-4">
          <v-stepper-item
            title="Order products"
            value="1"
            class="step1-background"
          ></v-stepper-item>
          <v-divider></v-divider>
          <v-stepper-item class="font-style" title="Promotion" value="2"></v-stepper-item>
          <v-divider></v-divider>
          <v-stepper-item class="font-style" title="Payment" value="3"></v-stepper-item>
        </v-stepper-header>
      </v-stepper>

      <v-stepper v-if="receiptStore.currentStep === 2" model-value="2">
        <!-- Step 2 content -->
        <v-stepper-header class="bg-teal-darken-4">
          <v-stepper-item
            complete
            title="Order products"
            value="1"
            color="light-green-darken-4"
          ></v-stepper-item>
          <v-divider></v-divider>
          <v-stepper-item title="Promotion" value="2"></v-stepper-item>
          <v-divider></v-divider>
          <v-stepper-item title="Payment" value="3"></v-stepper-item>
        </v-stepper-header>
      </v-stepper>

      <v-stepper v-if="receiptStore.currentStep === 3" model-value="3">
        <!-- Step 3 content -->
        <v-stepper-header class="bg-teal-darken-4">
          <v-stepper-item
            complete
            title="Order products"
            value="1"
            color="light-green-darken-4"
          ></v-stepper-item>
          <v-divider></v-divider>
          <v-stepper-item
            complete
            title="Promotion"
            value="2"
            color="light-green-darken-4"
          ></v-stepper-item>
          <v-divider></v-divider>
          <v-stepper-item title="Payment" value="3"></v-stepper-item>
        </v-stepper-header>
      </v-stepper>
      <div flex justify-center pt-16 pb-6>
        <br />
      </div>
      <v-container v-if="receiptStore.currentStep === 1">
        <v-row>
          <v-col>
            <v-sheet min-width="400" width="570" height="750" elevation="6" color="#967259">
              <v-tabs v-model="tab" color="white" align-tabs="center" class="bg-teal-darken-4">
                <v-tab :value="1"> <v-icon>mdi-glass-cocktail</v-icon>Drink</v-tab>
                <v-tab :value="2"> <v-icon>mdi-cupcake</v-icon>Dessert</v-tab>
                <v-tab :value="3"> <v-icon>mdi-food</v-icon>Food</v-tab>
              </v-tabs>
              <v-window v-model="tab">
                <v-window-item :value="1">
                  <ProductList
                    :products="posStore.products1"
                    @selectedProduct="selected"
                  ></ProductList>
                </v-window-item>
                <v-window-item :value="2">
                  <ProductList
                    :products="posStore.products2"
                    @selectedProduct="selected"
                  ></ProductList>
                </v-window-item>
                <v-window-item :value="3">
                  <ProductList
                    :products="posStore.products3"
                    @selectedProduct="selected"
                  ></ProductList>
                </v-window-item>
              </v-window>
            </v-sheet>
          </v-col>

          <v-col v-if="receiptStore.currentStep === 1" cols="12" md="6">
            <v-container style="padding: 0">
              <v-row>
                <v-col>
                  <div ref="divReceiptItems" style="height: 300; overflow: auto">
                    <v-sheet
                      min-width="300"
                      max-width="600"
                      height="650"
                      elevation="6"
                      color="#3D3D3D80"
                    >
                      <ReceiptDetailTable></ReceiptDetailTable>
                    </v-sheet>
                  </div>

                  <v-sheet
                    min-width="400"
                    width="573"
                    height="95px"
                    elevation="6"
                    class="bg-teal-darken-4"
                  >
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="6">
                          <v-btn block rounded="xl" size="x-large" color="error" @Click="clear()"
                            >Cancel</v-btn
                          >
                        </v-col>
                        <v-col cols="12" sm="6">
                          <v-btn
                            block
                            rounded="xl"
                            color="green"
                            size="x-large"
                            @Click="receiptStore.nextStep()"
                            >Next</v-btn
                          >
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-sheet>
                </v-col>
              </v-row>
            </v-container>
          </v-col>
        </v-row>
      </v-container>

      <v-container v-if="receiptStore.currentStep === 2">
        <v-row>
          <v-col cols="12" md="6">
            <v-container style="padding: 0">
              <v-row>
                <v-col>
                  <div ref="divReceiptItems" style="height: 300; overflow: auto">
                    <v-sheet
                      min-width="300"
                      max-width="600"
                      height="650"
                      elevation="6"
                      color="#3D3D3D80"
                    >
                      <ReceiptDetailTable></ReceiptDetailTable>
                    </v-sheet>
                  </div>
                </v-col>
              </v-row>
            </v-container>
          </v-col>

          <v-col cols="12" md="6">
            <v-row>
              <v-col>
                <v-sheet min-width="300" max-width="600" height="70" elevation="6" color="#634832">
                  <MemberCard></MemberCard>
                </v-sheet>
              </v-col>
            </v-row>

            <v-row>
              <v-col>
                <v-sheet min-width="300" max-width="600" height="70" elevation="6" color="#634832">
                  <ReceiptPromotion></ReceiptPromotion>
                </v-sheet>
              </v-col>
            </v-row>

            <v-row>
              <v-col>
                <v-sheet min-width="250" max-width="600" height="250" elevation="6" color="#634832">
                  <ReceiptCard></ReceiptCard>
                </v-sheet>
              </v-col>
            </v-row>

            <v-row>
              <v-col>
                <v-sheet
                  min-width="570"
                  max-width="600"
                  height="80"
                  elevation="6"
                  class="bg-teal-darken-4"
                >
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-btn block rounded="xl" size="x-large" @click="receiptStore.prevStep()"
                          >Back</v-btn
                        >
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-btn
                          block
                          rounded="xl"
                          color="green"
                          size="x-large"
                          @click="receiptStore.nextStep()"
                          >Next Step</v-btn
                        >
                      </v-col>
                    </v-row>
                  </v-container>
                </v-sheet>
              </v-col>
            </v-row>
          </v-col>
        </v-row>
      </v-container>
      <v-container v-if="receiptStore.currentStep === 3">
        <v-row>
          <v-col cols="12" md="6">
            <v-container style="padding: 0">
              <v-row>
                <v-col>
                  <div ref="divReceiptItems" style="height: 300; overflow: auto">
                    <v-sheet
                      min-width="300"
                      max-width="600"
                      height="650"
                      elevation="6"
                      color="#3D3D3D80"
                    >
                      <ReceiptDetailTable></ReceiptDetailTable>
                    </v-sheet>
                  </div>
                </v-col>
              </v-row>
            </v-container>
          </v-col>

          <v-col cols="12" md="6">
            <v-row>
              <v-col>
                <v-sheet min-width="250" max-width="600" height="260" elevation="6" color="#634832">
                  <ReceiptCard></ReceiptCard>
                </v-sheet>
              </v-col>
            </v-row>

            <v-row>
              <v-col>
                <v-sheet min-width="250" max-width="600" height="260" elevation="6" color="#634832"
                  ><ReceiptPayment></ReceiptPayment>
                </v-sheet>
              </v-col>
            </v-row>
            <v-row>
              <v-col>
                <v-sheet
                  min-width="570"
                  max-width="600"
                  height="80"
                  elevation="6"
                  class="bg-teal-darken-4"
                >
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-btn
                          block
                          rounded="xl"
                          size="large"
                          @Click="receiptStore.prevStep(), memberStore.clear()"
                          >Back</v-btn
                        >
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-btn block rounded="xl" color="green" size="large" @Click="showReceipt()"
                          >Payment</v-btn
                        >
                      </v-col>
                    </v-row>
                  </v-container>
                </v-sheet>
              </v-col>
            </v-row>
          </v-col>
        </v-row>
      </v-container>
      <ReceiptDialog />
    </v-container>
  </div>
</template>

<style scoped>
/* Import custom font from Google Fonts */
/* @import url('https://fonts.googleapis.com/css2?family=Kanit&display=swap'); */

/* @import url('https://fonts.googleapis.com/css2?family=Noto+Sans+Thai:wght@100..900&display=swap'); */

/* div {
  font-family: 'Noto Sans Thai', sans-serif;
} */

@import url('https://fonts.googleapis.com/css2?family=Patrick+Hand&display=swap');
.custom-header {
  color: #ffffff;
}
/* Apply custom font to specific elements */
div {
  font-family: 'Patrick Hand', cursive;
}

/* .font-style {
  font-family: 'Kanit', sans-serif;
} */
/* body {
  font-family: 'Kanit', sans-serif;
} */
</style>
